/* 
Scrivere un programma per la gestione delle prenotazioni dei voli. Ogni  volo  caratterizzato dalle seguenti informazioni: Cognome e Nome, codice volo (esempio AZ5141 o IV5372), codice prenotazione, giorno del volo.
Le prenotazioni  sono organizzate in memoria come una vettore di 50 prenotazioni.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Inserimento di una nuova prenotazione;
2)Visualizzazione delle prenotazioni relative a un certo volo e a una certo giorno (chiedere codice volo e giorno);
3) Ricerca di una prenotazione (chiedere il codice prenotazione);
4) Salvataggio su file delle prenotazioni relative a un certo giorno.

All'avvio del programma i valori precedentemente salvate su file devono essere letti e copiati nel vettore mediante una funzione di inizializzazione del vettore. 


 */


#include <stdio.h>
#include <string.h>

struct prenota
{
       char cognome[40];
       char nome[40];
       char codicevolo[40];
       int codiceprenotazione;
       char giorno [12];
};



void inserisci (struct prenota *V, int *pn)
{
     struct prenota p;
     printf ("Cognome: ");
     scanf ("%s", p.cognome);
     printf ("Nome: ");
     scanf ("%s", p.nome);
     printf ("Codice volo: ");
     scanf ("%s", p.codicevolo);
     printf ("Codice prenotazione: ");
     scanf ("%d", &p.codiceprenotazione);
     printf ("Giorno: ");
     scanf ("%s", p.giorno);
     if (*pn<50)
     {
                V[*pn]=p;
                (*pn)++;
     }
     else printf ("VETTORE PIENO\n");
}



void visualizza (struct prenota *V, int n)
{
     int i;
     char codicevolo [40];
     char giorno [12];
     
     printf ("Codice volo: ");
     scanf ("%s", codicevolo);
     printf ("Giorno: ");
     scanf ("%s", giorno);
     
     for (i=0;i<n;i++)
       if (strcmp(V[i].codicevolo,codicevolo)==0 && strcmp(V[i].giorno,giorno)==0)
          {
               printf ("Cognome: %s\n", V[i].cognome);
               printf ("Nome: %s\n", V[i].nome);
               printf ("Codice prenotazione: %d\n", V[i].codiceprenotazione);
          }
}
       


void ricerca (struct prenota *V, int n)
{
     int i, codiceprenotazione;
     printf ("Codice prenotazione: ");
     scanf ("%d", &codiceprenotazione);
     
     for (i=0;i<n;i++)
        if (V[i].codiceprenotazione==codiceprenotazione)
          break;
          
     if(i<n) /* trovato */
     {
            printf ("Cognome: %s\n", V[i].cognome);
            printf ("Nome: %s\n", V[i].nome);
            printf ("Codice volo: %s\n", V[i].codicevolo);
            printf ("Giorno: %s\n", V[i].giorno);
     }
     else printf ("NON TROVATO\n");
}
     
     

void salva (struct prenota *V, int n)
{
     FILE *pf;
     int i;
     char giorno [12];
     
     printf ("Giorno: ");
     scanf ("%s", giorno);
     
     pf=fopen ("prenotazioni.dat","wb");
     if (pf)
     {
            for (i=0;i<n;i++)
               if (strcmp (V[i].giorno,giorno)==0)
                    fwrite (&V[i], sizeof (struct prenota),1,pf);
            fclose (pf);
     }
     else printf ("ERRORE\n");
}



void inizializza (struct prenota *V, int *pn)
{
     FILE *pf;
     int i=0;
     struct prenota p;
     
     pf=fopen ("prenotazioni.dat","rb");
     if (pf)
     {
            while (i<50 && fread (&p, sizeof (struct prenota),1,pf)>0);
            {
                  V[i]=p;
                  i++;
            }
            fclose (pf);
     }
     else printf ("ERRORE IN LETTURA\n");
     *pn=i;
}



main ()
{
     struct prenota P[50];
     int n,scelta;
     
     inizializza (P, &n);
     do
     {
            printf ("SCEGLI TRA LE SEGUENTI OPZIONI: \n");
            printf ("1) INSERIMENTO\n2) VISUALIZZAZIONE\n3) RICERCA\n4) SALVA\n0) FINE\n");
            scanf ("%d", &scelta);
            switch (scelta)
            {
                   case 1: inserisci (P, &n);
                           break;
                   case 2: visualizza (P, n);
                           break;
                   case 3: ricerca (P, n);
                           break;
                   case 4: salva (P, n);
                           break;
                   default:;
            }
     }
     while (scelta!=0);
}
