/*
Scrivere un programma per la gestione delle prenotazioni degli esami per la patente di guida. Ogni  prenotazione  caratterizzata dalle seguenti informazioni: nominativo, codice fiscale, tipo di patente, giorno dell'esame.
Le prenotazioni  sono organizzate in memoria come una vettore di 65 prenotazioni.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Inserimento di una nuova prenotazione;
2)Visualizzazione delle prenotazioni relative a una certo tipo di patente e a una certo giorno (chiedere tipo di patente e giorno);
3) Cancellazione di una prenotazione (chiedere il codice fiscale);
4) Salvataggio su file delle prenotazioni;
5) Lettura da file e copia nel vettore delle prenotazioni relative a un certo giorno.

*/


#include <stdio.h>
#include <string.h>

struct prenota 
{
       char nominativo [40];
       char codice [17];
       int tipo;
       char giorno [11];
};

void inserimento (struct prenota *V,int *pn)
{
     struct prenota p;
     
     if(*pn<65)
     {
               printf("Nominativo: ");
               scanf("%s",p.nominativo);
               printf("Codice fiscale: ");
               scanf("%s",p.codice);
               printf("Tipo di patente: ");
               scanf("%d",&p.tipo);
               printf("Giorno dell'esame (gg/mm/aaaa): ");
               scanf("%s",p.giorno);
               
               V[*pn]=p;
               (*pn)++;
     }
     else printf("Vettore pieno\n");
}

void visualizzazione (struct prenota *V,int n)
{
     int i,tipo;
     char giorno [11];
     
     if(n==0)
       {
          printf("Vettore vuoto\n");
          return;
       }   
       
     printf("Tipo di patente: ");
     scanf("%d",&tipo);
     printf("Giorno dell'esame (gg/mm/aaaa): ");
     scanf("%s",giorno);
     
     for(i=0;i<n;i++)
       if(V[i].tipo==tipo && strcmp(V[i].giorno,giorno)==0)
            {
                        printf("Nominativo: %s\n",V[i].nominativo);
                        printf("Codice fiscale: %s\n",V[i].codice);
            }
}

void cancellazione (struct prenota *V,int *pn)
{
     int i,k;
     char codice [17];
     
     if(*pn==0)
       {
          printf("Vettore vuoto\n");
          return;
       } 
       
     printf("Codice fiscale: ");
     scanf("%s",codice);
     
     for(i=0;i<*pn;i++)
        if(strcmp(V[i].codice,codice)==0)
            break;
     
     if(i<*pn) /* trovato*/
     {
              for(k=i;k<*pn-1;k++)
                  V[i]=V[i+1];
                                  
              (*pn)--;
              
     }
     else printf("Elemento non trovato\n");
}

void salvataggio (struct prenota *V,int n)
{
     int i;
     FILE *pf;
     
     pf=fopen("Prenotazioni.dat","wb");
     if(pf)
     {
           for(i=0;i<n;i++)
               fwrite(&V[i],sizeof(struct prenota),1,pf);
           fclose(pf);
     }
     else printf("Errore in scrittura\n");
}

void lettura_copia (struct prenota *V,int *pn)
{
     struct prenota p;
     int i;
     char giorno [11];
     FILE *pf;
     
     i=0;
     printf("Giorno dell'esame (gg/mm/aaaa): ");
     scanf("%s",giorno);
     
     pf=fopen("Prenotazioni.dat","rb");
     if(pf)
     {
           while(i<65 && fread(&p,sizeof(struct prenota),1,pf)>0)
              if(strcmp(p.giorno,giorno)==0)
                    {
                      V[i]=p;
                      i++;
                    }
           fclose(pf);
     }
     else printf("Errore in lettura\n");
     (*pn)=i;
}

main ()
{
     struct prenota P[65];
     int scelta,n;
     
     n=0;
     do {
            printf("\nScegli tra:\n");
            printf("1) Inserimento\n2) Visualizzazione\n3) Cancellazione\n");
            printf("4) Salvataggio\n5) Lettura e copia\n0) Fine esecuzione\n");
            scanf("%d",&scelta);
            
            switch(scelta)
            {
                          case 1: inserimento(P,&n);
                                  break;
                          case 2: visualizzazione(P,n);
                                  break;
                          case 3: cancellazione(P,&n);
                                  break;
                          case 4: salvataggio(P,n);
                                  break;
                          case 5: lettura_copia(P,&n);
                                  break;
                          default: ;
            }
        }
        while(scelta!=0);
}                                        
